<?php
session_name('ppp_session_id');
session_start();

class SimpleCaptcha
{
    private $captchaString;
    private $imageWidth;
    private $imageHeight;
    private $font;

    public function __construct($width = 200, $height = 50, $font = 5)
    {
        $this->imageWidth = $width;
        $this->imageHeight = $height;
        $this->font = $font;
        $this->captchaString = $this->generateCaptchaString();
        $_SESSION['captcha'] = $this->captchaString;
    }

    private function generateCaptchaString($length = 6)
    {
        $characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }

    public function createCaptchaImage()
    {
        $image = imagecreatetruecolor($this->imageWidth, $this->imageHeight);

        $bgColor = imagecolorallocate($image, 255, 255, 255); // 白
        $textColor = imagecolorallocate($image, 0, 0, 0); // 黒
        $lineColor = imagecolorallocate($image, 64, 64, 64); // 灰色

        imagefilledrectangle($image, 0, 0, $this->imageWidth, $this->imageHeight, $bgColor);

        // ランダムな線を描画
        /*
        for ($i = 0; $i < 10; $i++) {
            imageline($image, rand(0, $this->imageWidth), rand(0, $this->imageHeight), rand(0, $this->imageWidth), rand(0, $this->imageHeight), $lineColor);
        }*/

        // CAPTCHA文字列を画像に描画
        $fontWidth = imagefontwidth($this->font);
        $fontHeight = imagefontheight($this->font);
        $textWidth = $fontWidth * strlen($this->captchaString);
        $textX = ($this->imageWidth - $textWidth) / 2;
        $textY = ($this->imageHeight - $fontHeight) / 2;

        imagestring($image, $this->font, (int)$textX, (int)$textY, $this->captchaString, $textColor);

        // 画像を出力
        header('Content-Type: image/png');
        imagepng($image);
        imagedestroy($image);
    }

    public function verifyCaptcha($input)
    {
        return $input === $_SESSION['captcha'];
    }
}
