<?php

/********************************************************************
 *
 * コンソールページ
 *
 *  GET q   : 記事絞込用の検索ワード。スペース区切りで複数指定するとAND検索。
 *      page: ページネーション時の表示対象ページ番号。
 *
 ********************************************************************/

//共通処理呼び出し
$require_login = true; //ログイン必要
require_once("./common.php");
refreshToken("./"); //ログイントークンをリフレッシュ
//キャッシュ無効
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma:no-cache');
//タグクラウド用データ読み取り
require_once('./env/tagcloud.php');
$records_per_page = 30; //1ページ当たりの表示件数

$searchs =  filter_input(INPUT_GET, 'q');
$index =  filter_input(INPUT_GET, 'page', FILTER_VALIDATE_INT);
$sort_type = filter_input(INPUT_GET, 'sort_type') ?? 0;

$limit = $records_per_page;
$offset = 0;
if ($index != "") {
    $offset = ($index - 1)  * $records_per_page;
}

$sort_type_select = range(0, 8);
$sort = "";
$sort_type_select[$sort_type] = "selected";
$sort_list = [
    "created_at desc",
    "created_at asc",
    "updated_at desc",
    "updated_at asc",
    "views desc",
    "views asc",
    "like desc, created_at desc",
    "like asc, created_at desc",
];
$sort = $sort_list[$sort_type];


$rowCount = 0;
try {
    // SELECT 文を実行してデータを取得
    if ($searchs == "") {
        $rowCount = $db->querySingle('SELECT Count(id) as count From articles');
        $pages = ceil($rowCount / $records_per_page);

        $result = $db->query('SELECT * From articles ORDER BY ' . $sort . ' LIMIT ' . $records_per_page . ' OFFSET ' . $offset);
    } else {
        //検索条件が指定された場合、SQLでの検索条件式を構築する。
        $search_list = '';
        $search_idx = 0;
        $search_and = '';
        foreach (explode(' ', $searchs) as $search) {
            if ($search == ":hidden") {
                $search_list = $search_list .  $search_and . "(hidden = true)";
            } elseif ($search == ":pin") {
                $search_list = $search_list .  $search_and . "(pin = true)";
            } elseif ($search == ":nsfw") {
                $search_list = $search_list .  $search_and . "(nsfw = true)";
            } elseif ($search == ":fix") {
                $search_list = $search_list .  $search_and . "(style = 99)";
            } elseif (substr($search, 0, 1) == "#") {
                $search_list = $search_list .  $search_and . "(tags like :search{$search_idx} or tags like :search_m{$search_idx})";
            } else {
                $search_list = $search_list .  $search_and . "(title like :search{$search_idx} or comment like :search{$search_idx} or tags like :search{$search_idx})";
            }
            $search_and = ' and ';
            $search_idx++;
        }
        $stmt = $db->prepare('SELECT Count(id) as count From articles Where ' . $search_list);

        $search_idx = 0;
        foreach (explode(' ', $searchs) as $search) {
            if ($search[0] == '#') {
                $stmt->bindValue(":search{$search_idx}", '% ' . substr($search, 1) . ' %');
                $stmt->bindValue(":search_m{$search_idx}", '% -' . substr($search, 1) . ' %');
            } elseif ($search[0] != ':') {
                $stmt->bindValue(":search{$search_idx}", '%' . $search . '%');
            }
            $search_idx++;
        }
        $result = $stmt->execute();
        $row = $result->fetchArray();
        $rowCount = $row['count'];
        $pages = ceil($rowCount / $records_per_page);

        $stmt = $db->prepare('SELECT *  From articles Where ' . $search_list . ' ORDER BY  ' . $sort . '  LIMIT ' . $records_per_page . ' OFFSET ' . $offset);
        $search_idx = 0;
        foreach (explode(' ', $searchs) as $search) {
            if ($search[0] == '#') {
                $stmt->bindValue(":search{$search_idx}", '% ' . substr($search, 1) . ' %');
                $stmt->bindValue(":search_m{$search_idx}", '% -' . substr($search, 1) . ' %');
            } elseif ($search[0] != ':') {
                $stmt->bindValue(":search{$search_idx}", '%' . $search . '%');
            }
            $search_idx++;
        }
        $result = $stmt->execute();
    }

    $idx = 0;
    $rowsarray = array();
    $list_html = "";
    while ($row = $result->fetchArray()) {
        $created_at = h($row['created_at']);
        $title = h($row['title']);
        $id = h($row['id']);
        $like = h($row['like']);
        $views = h($row['views']);
        $comment = $row['comment'];
        $pin = $row['pin'] ?? false;
        if ($comment) {
            preg_match('/{caption}(.*?){\/caption}/si', $comment, $match);
            if ($match) {
                //キャプションがある場合はそれを使用
                $comment = $match[1];
            }
            $comment = mb_substr(strip_tags($comment), 0, 100);
            //特殊記述の削除
            $comment = preg_replace('/\{.*\}/', '', $comment);
            $comment = strip_tags($comment);
        }

        $thumbs = $db->query('SELECT id, file_name, thumb_name FROM images where article_id = ' . $id . ' order by sort asc');
        $thumbsarray = array();
        $tidx = 0;
        $trow = $thumbs->fetchArray();
        $item_html = "";
        if ($trow) {
            $file_name =  h($trow['thumb_name']);
            $item_html = "<div class='list-thumb-box' style=\"background-image:url('./images/{$file_name}')\"></div>";
        } else {
            $item_html = "<div class='blank-image'></div>";
        }
        $feedbacks = "";
        if ($SETTING["use_feedback"]) {
            $feedbacks = "<span class='like-it'><i class='fa-regular fa-eye'></i> {$views}</span></span> <span class='nowarp'><span class='like-it'><i id='like_heart' class='fa-regular fa-heart'></i> {$like}</span></span>";
        }
        if ($pin) {
            $feedbacks = $feedbacks . ' <span class="pin"><i class="fa-solid fa-thumbtack"></i></span>';
        }
        $list_html = $list_html . "<li><div class='check_area'><input type='checkbox' class='delete_check' data-id='{$id}'></div>" .
            "<a href='./edit.php?id={$id}'>{$item_html}</a>" .
            "<div class='list-info'><span class='created_at'>{$created_at}</span> <span class='nowarp'>{$feedbacks}<br />" .
            "<a href='./edit.php?id={$id}'><span class='title'>{$title}</span><br /><span class='comment'>{$comment}</span></a></div></li>";
    }
    $db->close();

    $message = "";
    if ($rowCount == "0") {
        if ($searchs == "") {
            $message = "<div id='message'>まだ記事は投稿されていません</div>";
        } else {
            $message = "<div id='message'>「 " . h($searchs) . "」に該当する記事は見つかりません</div>";
        }
    }

    $indexser = "";
    $indexser_search = "";
    if ($searchs) {
        $indexser_search = "&q=" . urlencode($searchs);
    }
    for ($i = 1; $i <= $pages; $i++) {
        if ($i == $index) {
            $indexser = $indexser . $i . ' ';
        } else {
            $indexser = $indexser . '<a href="?page=' . $i .  $indexser_search . "&sort_type=" . $sort_type . '">' . $i . '</a> ';
        }
    }
} catch (Exception $e) {
    echo $e->getMessage();
}

//UIレンダリング
require_once('./module/NoSixTemplate.php');
$template = new NoSixTemplate('template_console.php', './templates/');

$template->set_data('list_html', $list_html);
$template->set_data('message', $message);
$template->set_data('indexser', $indexser);
$template->set_data('sort_type_select', $sort_type_select);
$template->set_data('searchs', $searchs);
$template->set_data('VERSION', $VERSION);
$template->set_data('tagcloud_nolink', $tagcloud_nolink);
$template->set_data('tagcloud_nolink_more', $tagcloud_nolink_more);


$template->display();
