<!doctype html>
<html lang="ja">

<head>
    <meta charset="utf-8">
    <title>記事管理</title>
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="theme-color" content="#fafafa">
    <link rel="stylesheet" href="./style/recss.css">
    <link rel="stylesheet" href="./style/base.css">
    <link rel="icon" href="./resource/icon.png">
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="Cache-Control" content="no-cache">
    <link rel="stylesheet" href="./style/system.css">
    <style>
        #loglist {
            margin-top: 3em;
            margin-bottom: 3em;
        }

        #loglist li {
            height: 100px;
            overflow: hidden;
            margin-bottom: 5px;
            display: flex;
            flex-direction: row;
        }

        .blank-image {
            float: left;
            height: 100px;
            width: 100px;
            border: 1px solid #999;
            background-color: #eee;
        }

        .blank-image::before {
            content: "NO IMAGE";
            display: inline-block;
            text-align: center;
            line-height: 100px;
            width: 100px;
            color: #ccc;
        }

        .check_area {
            width: 3em;
            margin-right: 2em;
            display: flex;
            justify-content: center;
        }

        input[type="checkbox"].delete_check {
            margin-left: 1em;
            accent-color: var(--warn-d-color);
        }

        .list-thumb-box {
            float: left;
            height: 100px;
            width: 100px;
            background-color: #999;
            border: 1px solid #999;
            overflow: hidden;
            background-size: cover;
            background-position: center center;
        }

        .list-thumb {
            max-height: 200px;
            margin: 0 auto 0 auto;
        }

        .list-info {
            float: left;
            margin-left: 1em;
            overflow: hidden;
            width: calc(90% - 102px);
        }

        #pager {
            margin-top: 2em;
            font-size: 1.5em;
            text-align: center;
        }



        .created_at {
            font-size: 0.8em;
        }

        .like-it {
            font-size: 0.7em;
        }

        .pin {
            font-size: 0.6em;
        }

        .comment {
            font-size: 0.8em;
            max-height: 2em;
            overflow: hidden;
        }

        .comment br {
            display: none;
        }

        .comment br::after {
            content: "  ";
        }

        .title {
            font-weight: 600;
        }

        .nowarp {
            white-space: nowrap
        }

        a {
            color: #777;
            text-decoration: none;
        }

        a:hover {
            color: #999;
            text-decoration: underline;
        }

        #control {
            margin-bottom: 2em;
            display: flex;
            width: 100%;
            flex-direction: row;
            flex-wrap: wrap
        }

        #add-new-button {
            margin-right: 1em;
            height: 2em;
            min-width: 40%;
            margin-bottom: 0.5em;
        }

        #search-area {
            position: relative;
            word-wrap: none;
        }

        #search {
            font-size: 120%;
            border: 1px solid #999;
            border-radius: 20px;
            height: 2em;
            color: #555;
            background-color: #fff;
            padding: 0 2em 0 2em;
            word-wrap: none;
            min-width: 20%;
        }

        #search-button {
            font-size: 130%;
            vertical-align: middle;
            position: absolute;
            display: inline-block;
            height: 1.8em;
            line-height: 1.8em;
            margin-left: 0.5em;
            cursor: pointer;
        }

        #search-clear-button {
            color: rgb(36, 180, 199);
            font-size: 140%;
            vertical-align: middle;
            display: inline-block;
            height: 1.4em;

            position: relative;
            right: 1.6em;

            cursor: pointer;
        }

        .magnifying_glass {
            display: inline-block;
            position: relative;
            width: 1em;
            height: 1em;
            color: #000;
            font-size: 1em;
        }

        .magnifying_glass::before {
            position: absolute;
            top: 0px;
            left: 0px;
            width: 0.7em;
            height: 0.7em;
            box-sizing: border-box;
            border: 0.15em solid currentColor;
            border-radius: 50%;
            background-color: #fff;
            content: "";
        }

        .magnifying_glass::after {
            position: absolute;
            top: 0px;
            left: 50%;
            z-index: -1;
            transform: rotate(-45deg);
            width: 0.15em;
            height: 1em;
            box-sizing: border-box;
            background-color: currentColor;
            content: "";
        }

        #notification {
            cursor: pointer;
        }

        em {
            font-weight: 800;
            font-style: normal;
        }

        #message {
            text-align: center;
        }

        #notification-link {
            color: #888;
        }

        #tagcloud_area {
            margin: 1em 2em 1em 2em;
        }

        .tag-cloud-more-link {
            color: var(--tag-cloud-back-color);
            font-size: 0.8em;
            display: inline-block;
            padding: 2px 0.5em 2px 0.5em;
            margin-right: 1em;
        }

        .tag-cloud-more-link:hover {
            color: var(--tag-cloud-back-color-hover);
        }

        .tag {
            background-color: var(--tag-cloud-back-color);
            color: var(--tag-cloud-font-color);

            font-size: 0.8em;
            display: inline-block;
            text-align: center;
            padding: 2px 0.5em 2px 0.5em;
            border-radius: 5px;
            margin-right: 1em;
            margin-bottom: 0.5em;
            min-width: 48px;

            cursor: pointer;
        }


        .tag:hover {
            color: var(--tag-cloud-font-color-hover);
            background-color: var(--tag-cloud-back-color-hover);

        }

        .tag a {
            color: var(--tag-cloud-font-color);
        }

        label {
            font-size: 0.8em;
            display: inline;
            margin-right: 0.5em;
        }

        select {
            font-size: 0.8em;
            display: inline;
            border: 1px solid #555;
            padding: 0.2em 0.4em 0.2em 0.4em;
            border-radius: 5px;
        }
    </style>
    <link rel="stylesheet" href="./module/fontawesome/css/all.min.css" rel="preload">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
    <script src="./script/dialog.js?ver=<?= $VERSION ?>"></script>
    <link rel="stylesheet" href="./style/dialog.css">
    <script src="./script/console.js?ver=<?= $VERSION ?>"></script>
</head>

<body>
    <div id="header">
        <a id="back-link" href="./index.php" class="header-link-exit">&lt; TOP</a>
        <div id="header-option-link-area">
            <span id="notification-link" href=""><i id="notification" class="fa-regular fa-bell font-size:1em"></i></span>
            <a id="setting-link" href="./setting.php"><i class="fa-solid fa-gear font-size:1em"></i>設定</a>
            <a id="logout-link" href="./logout.php">ログアウト</a>
        </div>
    </div>
    <div id="base">
        <div id="home_menu">
            <ul class="home_menu">
                <li class="home_menu_item home_menu_item_current" data-id="home">記事管理</li>
                <li class="home_menu_item" data-id="home"><a href="./console_message.php" id="home_menu_message">メッセージ</a></li>
            </ul>
        </div>
        <div id="control">
            <button id="add-new-button" class="button" onClick="location.href='./edit.php';">+<span id="add-new-title_pc"> 記事を作成</span></button>
            <div class="search-input">
                <i id="search-button" onClick="searchExec();" class="fa-solid fa-magnifying-glass"></i>
                <input type="input" id="search" onclick="this.select();" value="<?php echo h($searchs); ?>">
                <i id="search-clear-button" onClick="$('#search').val('')" class="fa-regular fa-circle-xmark"></i>
            </div>
        </div>
        <div id="console_tag_cloud">
            <?php echo ($tagcloud_nolink . $tagcloud_nolink_more) ?>
        </div>
        <div>
            <ul>
                <li class="tag search_word" data-search=":fix">固定ページ</li>
                <li class="tag search_word" data-search=":hidden">非表示記事</li>
                <li class="tag search_word" data-search=":pin">ピン止め記事</li>
                <li class="tag search_word" data-search=":nsfw">NSFW記事</li>
            </ul>
        </div>
        <div>
            <label for="sort_type">並び替え</label>
            <select id="sort_type" name="sort_type">
                <option value="0" <?= $sort_type_select[0] ?>>作成日時 ▽</option>
                <option value="1" <?= $sort_type_select[1] ?>>作成日時 △</option>
                <option value="2" <?= $sort_type_select[2] ?>>更新日時 ▽</option>
                <option value="3" <?= $sort_type_select[3] ?>>更新日時 △</option>
                <?php if ($SETTING["use_feedback"]) { ?>
                    <option value="4" <?= $sort_type_select[4] ?>>閲覧数 ▽</option>
                    <option value="5" <?= $sort_type_select[5] ?>>閲覧数 △</option>
                    <option value="6" <?= $sort_type_select[6] ?>>いいね数 ▽</option>
                    <option value="7" <?= $sort_type_select[7] ?>>いいね数 △</option>
                <?php } ?>
            </select>
        </div>

        <div id="contents-area">
            <?php echo $message ?>
            <ul id="loglist">
                <?php echo $list_html; ?>
            </ul>
            <div id="control">
                <button id="delete-button" class="button button_warn" onclick="deleteExec();">削除</button>
            </div>
            <div id="pager">
                <?php echo $indexser; ?>
            </div>
        </div>
    </div>


    <script>
        (async () => {
            if (await checkUnreadMessage()) {
                $("#home_menu_message").before("<i class=\"fa-solid fa-envelope\" style=\"color:rgb(204, 0, 0);margin-right:0.2em\"></i>");
            }
        })();
    </script>
</body>

</html>