<?php

//トークンを発行し、保存します
function publishToken($rel, $uid)
{
    if (!file_exists("{$rel}env/tokens.php")) {
        file_put_contents("{$rel}env/tokens.php", "<?php exit(); ?>\n");
    }
    // トークンを生成する
    $token = bin2hex(random_bytes(20));
    $enc_token = hash('sha256', $token);
    if (empty($_SERVER['HTTPS'])) {
        //HTTPの場合、短期間トークンにする
        $expiration = time() + (3 * 60 * 60); // 有効期限は3時間
        file_put_contents("{$rel}env/tokens.php", "$enc_token, $uid, $expiration\n", FILE_APPEND);
        setcookie(
            'n-token',
            $token
        );
    } else {
        // トークンの保存とTokenCookie発行
        $expiration = time() + (30 * 24 * 60 * 60); // 有効期限は30日後
        file_put_contents("{$rel}env/tokens.php", "$enc_token, $uid, $expiration\n", FILE_APPEND);
        setcookie(
            'token',
            $token,
            $expiration,
            '',
            '',
            true,
            true
        );
    }
}

//トークンを破棄します
function clearToken($rel)
{
    if (empty($_SERVER['HTTPS'])) {
        //HTTPの場合、短期間トークンにする
        $user_token = filter_input(INPUT_COOKIE, 'n-token');
        if ($user_token) {
            // トークンをファイルから読み込む
            $user_token = hash('sha256', $user_token);
            $tokens = explode("\n", file_get_contents("{$rel}env/tokens.php"));
            $wtokens = "";
            foreach ($tokens as $token_info) {
                $token_data = explode(",", $token_info);
                if (count($token_data) == 3 && $token_data[2] > time() && $user_token == $token_data[0]) {

                    $wtokens = $wtokens . "{$token_data[0]},{$token_data[1]},{$token_data[2]}\n";
                }
            }
            $wtokens = "<?php exit(); ?>\n" . $wtokens;
            file_put_contents("{$rel}env/tokens.php", $wtokens);
        }
        setcookie(
            'n-token',
            "--",
            time() + 1
        );
    } else {
        $user_token = filter_input(INPUT_COOKIE, 'token');
        if ($user_token) {
            $user_token = hash('sha256', $user_token);
            // トークンをファイルから読み込む
            $tokens = explode("\n", file_get_contents("{$rel}env/tokens.php"));
            $wtokens = "";
            foreach ($tokens as $token_info) {
                $token_data = explode(",", $token_info);
                if (count($token_data) == 3 && $token_data[2] > time() &&  !$user_token == $token_data[0]) {
                    $wtokens = $wtokens . "{$token_data[0]},{$token_data[1]},{$token_data[2]}\n";
                }
            }
            $wtokens = "<?php exit(); ?>\n" . $wtokens;
            file_put_contents("{$rel}env/tokens.php", $wtokens);
        }
        setcookie(
            'token',
            "--",
            time() + 1
        );
    }
}

function refreshToken($rel)
{
    // トークンをファイルから読み込む
    $tokens = explode("\n", file_get_contents("{$rel}env/tokens.php"));
    $wtokens = "";
    if (empty($_SERVER['HTTPS'])) {
        $user_token = filter_input(INPUT_COOKIE, 'n-token');
    } else {
        $user_token = filter_input(INPUT_COOKIE, 'token');
    }
    $user_token = hash('sha256', $user_token);
    $new_token = bin2hex(random_bytes(20));
    foreach ($tokens as $token_info) {
        $token_data = explode(",", $token_info);
        // 有効期限が切れていないトークンを取り出す
        if (count($token_data) == 3 && $token_data[2] > time()) {
            if ($user_token == $token_data[0]) {
                $enc_token = hash('sha256', $new_token);
                $expiration = time() + (30 * 24 * 60 * 60); // 有効期限は30日後
                $wtokens = $wtokens . "{$enc_token},{$token_data[1]},$expiration\n";
            } else {
                $wtokens = $wtokens . "{$token_data[0]},{$token_data[1]},{$token_data[2]}\n";
            }
        }
    }
    $wtokens = "<?php exit(); ?>\n" . $wtokens;
    file_put_contents("{$rel}env/tokens.php", $wtokens);
    if (empty($_SERVER['HTTPS'])) {
        setcookie(
            'n-token',
            $new_token
        );
    } else {
        setcookie(
            'token',
            $new_token,
            $expiration,
            '',
            '',
            true,
            true
        );
    }
}

function checkToken($rel)
{
    // トークンが有効か確認する
    if (empty($_SERVER['HTTPS'])) {
        $user_token = filter_input(INPUT_COOKIE, 'n-token');
    } else {
        $user_token = filter_input(INPUT_COOKIE, 'token');
    }
    if ($user_token == null || $user_token == "") {
        return null;
    }

    $enc_token = hash('sha256', $user_token);
    // トークンをファイルから読み込む
    $tokens = explode("\n", file_get_contents("{$rel}env/tokens.php"));
    $valid_tokens = array();

    foreach ($tokens as $token_info) {
        $token_data = explode(",", $token_info);
        // 有効期限が切れていないトークンを取り出す
        if (count($token_data) == 3 && $token_data[2] > time()) {
            if ($enc_token == $token_data[0]) {
                return $user_token;
            }
            $valid_tokens[$token_data[0]] = $token_data[1];
        }
    }
    return null;
}
